const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const sales_order_items = sequelize.define(
    'sales_order_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

designation: {
        type: DataTypes.TEXT,
      
      

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_label: {
        type: DataTypes.TEXT,
      
      

      },

unit_price_ht: {
        type: DataTypes.DECIMAL,
      
      

      },

discount_percent: {
        type: DataTypes.DECIMAL,
      
      

      },

tax_rate_percent: {
        type: DataTypes.DECIMAL,
      
      

      },

line_total_ht: {
        type: DataTypes.DECIMAL,
      
      

      },

line_tax_total: {
        type: DataTypes.DECIMAL,
      
      

      },

line_total_ttc: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  sales_order_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity






































//end loop



    db.sales_order_items.belongsTo(db.sales_orders, {
      as: 'sales_order',
      foreignKey: {
        name: 'sales_orderId',
      },
      constraints: false,
    });

    db.sales_order_items.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.sales_order_items.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.sales_order_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.sales_order_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return sales_order_items;
};


